	
		
		//------------------------------------------------------------------------------------
		var word_index = 0;
		var viseme_index = 0;
		var previous_audio_pos = 0;
		var current_audio_pos = 0;
		var event_callback_id;

		function event_callback() {

			current_audio_pos = audio_context.currentTime * 1000;

			if (word_index < words.length) {

				if (((words[word_index].time * 1000) <= current_audio_pos + 100) && ((words[word_index].time * 1000) >= current_audio_pos - 100) && current_audio_pos != 0) {
					print(words[word_index].word);
					word_index++;
				}

			}
			if (viseme_index < visemes.length) {

				if (((visemes[viseme_index].time * 1000) <= current_audio_pos + 100) && ((visemes[viseme_index].time * 1000) >= current_audio_pos - 100) && current_audio_pos != 0) {
					print(visemes[viseme_index].viseme);
					viseme_index++;
				}
			}

			previous_audio_pos = current_audio_pos;

			if ((word_index < words.length) && (viseme_index < visemes.length)) {
				return;
			}
		}


		//------------------------------------------------------------------------------------
		function appendBuffer(buffer1, buffer2) {
			var tmp = new Uint8Array(buffer1.byteLength + buffer2.byteLength);
			var buff1 = new Uint8Array(buffer1);
			var buff2 = new Uint8Array(buffer2);
			tmp.set(buff1, 0);
			tmp.set(buff2, buffer1.byteLength);
			return tmp.buffer;
		};


		//------------------------------------------------------------------------------------
		var audio_context;
		var audio_source = 0;
		var audio_stream = 0;
		var audio_current_time = 0;
		var audio_started = 0;
		var audio_stopped = 0;

		async function play_audio_buffers(audio_buffers) {


			if (audio_buffers.length > 0) {
			
				const audioBuffer = audio_buffers.shift();

				// append audio buffer to the audio stream
				if (audio_stream == 0) {
					audio_stream = audioBuffer;
					audio_context = new AudioContext();
					audio_started = 1;
					
					// Start monitoring audio position to display words and visemes
					event_callback_id = window.setInterval(event_callback, 50);

				} else {

					audio_stream = appendBuffer(audio_stream,  audioBuffer);
				}

				var buf = audio_stream.slice(0);

				audio_context.decodeAudioData(buf, (decodedBuffer) => {

					// stop audio
					try {
						audio_source.stop(0.015);
					} catch (e) { 

					}

					// fill audio source with the updated audio stream and keep playing from latest position
					audio_source = audio_context.createBufferSource();
					audio_source.buffer = decodedBuffer;
					audio_source.connect(audio_context.destination);

					audio_source.onended = function () {
				
					};

					audio_current_time = audio_context.currentTime;

					if (audio_current_time == 0) {
						audio_source.start(audio_current_time);
					} else {
						audio_source.start(0.010,audio_current_time,decodedBuffer.duration);
					}

				});

			}
	
		}


		//------------------------------------------------------------------------------------
		var buffer = [];
		var buffer_type = "";
		var buffer_size = 0;
		var buffer_byte_read = 0;
		var events = [];
		var audio = [];
		var audio_buffers = [];
		var buffer_string = "";
		var buffer_ready = 0;


		function parse_chunk(chunk) {

			for (const byte of chunk) {

				const character = String.fromCharCode(byte);
				buffer.push(character);
				buffer_string += character;

				// Read buffer type and len
				if ((buffer_string.includes("events:") || buffer_string.includes("audio:")) && character === "\n") {
					const bufferInfo = buffer_string.split(':');
					buffer_type = bufferInfo[0];
					buffer_size = parseInt(bufferInfo[1], 10);
					buffer.length = 0; 
					//console.log(`buffer: ${buffer_type} - ${buffer_size}`);
					buffer_string = "";

				// Read buffer content
				} else if (buffer_type !== "") {
					
					buffer_byte_read++;

					if (buffer_type.includes("events")) {
						const byteAsBytes = new Uint8Array([byte]);
						events.push(byteAsBytes);
					} else if (buffer_type.includes("audio")) {
						const byteAsBytes = new Uint8Array([byte]);
						audio.push(byteAsBytes);
					}

					if (buffer_byte_read === buffer_size) {
						//console.log(`buffer : complete - ${buffer_byte_read}`);

						if (buffer_type.includes("audio")) {
							//console.log(`audio buffer : complete - ${buffer_byte_read}`);

							const buffer = new ArrayBuffer(audio.length);
							const view = new Uint8Array(buffer);
							audio.forEach((byte, i) => {
								view[i] = byte[0]; 
							});

							audio_buffers.push(buffer.slice(0));

							// wait we have at least two buffer before playing
							buffer_ready = buffer_ready + 1;
							if (buffer_ready > 1) {
								play_audio_buffers(audio_buffers);
							}

							audio = [];
						}

						if (buffer_type.includes("events")) {

							const events_array = new Uint8Array(events);
							const events_string = new TextDecoder().decode(events_array);
							//console.log(events_string);

							parse_events(events_string);
							events = [];
						}
				
						buffer.length = 0; 
						buffer_type = "";
						buffer_size = 0;
						buffer_byte_read = 0;
						buffer_string = "";

					}
				}

			}

			return;

		}

		//------------------------------------------------------------------------------------
		function sleep(ms) {
			return new Promise(resolve => setTimeout(resolve, ms));
		}

		//------------------------------------------------------------------------------------
		async function stream_audio_events(url) {

			// if a previous audio was playing wait it exists
			if (audio_started == 1) {
				audio_stopped = 1;
				audio_context.close();
				audio_started = 0;
				await sleep(300);
			}


			// events
			words = [];
			visemes = [];
			word_index = 0;
			viseme_index = 0;
			previous_audio_pos = 0;
			current_audio_pos = 0;

			// buffer
			buffer = [];
			buffer_type = "";
			buffer_string = "";
			buffer_size = 0;
			buffer_ready = 0;

			buffer_byte_read = 0;
			events = [];
			audio = [];
			audio_buffers = [];
			audio_started = 0;
			audio_stopped = 0;

			// audio
			audio_context = {};
			audio_source = 0;
			audio_stream = 0;
			audio_current_time = 0;

			fetch(url).then(function(response) {
				if ((response.status) != 200) {

					alert(result.error);
	
					return;
	
				}
				var reader = response.body.getReader();
				function read() {
					return reader.read().then(({ value, done })=> {

						// we clicked on stop
						if (audio_stopped == 1) {
							return;
						}

						if (!done) {
							parse_chunk(value);
						}

						if (done) {

							// Finish to play all the buffers
							while (audio_buffers.length > 0 && audio_stopped == 0) {
								play_audio_buffers(audio_buffers);
							}

							return;
						}
						read();
					});
				}
				read();
			})


		}


		//------------------------------------------------------------------------------------
		// Send command
		function speak() {

			var token = "enter your token or get it after you calle dlogin function";

			// Get Text and params
			var text = " 1 2 3 4"

			var voice = "Manon22k_HQ"
			var type = "mp3"

			var output = "stream";

			var wordpos = "on"
			var mouthpos = "on"

			var speed = "100"
			var shaping = "100"
			var volume = "32768"

			var samplerate = "22050"

			var dico = "";

			if (type == "mp3")
				src_type = "audio/mpeg";
			

			var url = "{% url 'api_command' %}" + "?voice=" + voice + "&text=" + encodeURIComponent(text) + "&output=" + output + "&type=" + type + "&samplerate=" + samplerate + "&wordpos=" + wordpos + "&mouthpos=" + mouthpos + "&speed=" + speed + "&shaping=" + shaping +
				"&volume=" + volume + "&dico=" + dico + "&token=" + token


			// Start streaming
			stream_audio_events(url);

			return;
		}
